; Файл : main.a51
; Микроконтроллер : АТ89С52
; Ассемблер : А51 v.8.2.5.0 Keil
; Проект : zadan1.uv4
; Автор : Ефремов Константин Михайлович
; Дата : 30.11.20
;------------------------------------------------------------------------------------------------------------------------
DSEG AT 030h ; сегмент внутренней памяти данных с адреса 030h
Arr: DS 14 ; резервируем место под набор из семи 2-байтовых чисел

B_ EQU 1be1h ; второй операнд (число B)

CSEG AT 000h ; сегмент кода с адреса 0
Start:
; инициализация набора чисел значениями
MOV R0, #Arr ; загрузка адреса массива в регистр R0
MOV DPTR, #iniA ; загрузка адреса массива в памяти команд в DPTR
MOV R2, #14 ; счетчик байтов
lp_ini:
CLR A ; обнуляем аккумулятор
MOVC A, @A+DPTR ; считываем байт из памяти программ в аккумулятор
MOV @R0, A ; записываем значение аккумулятора в ОЗУ по адресу в R0
INC R0 ; инкремент адреса в R0
INC DPTR ; инкремент адреса в DPTR
DJNZ R2, lp_ini ; цикл, пока R2 > 0

; выполнение логической операции "НЕ": «НЕ»: ¬A[i]
MOV R0, #Arr ; загрузка адреса массива в регистр R0
MOV R2, #14 ; счетчик байтов
lp_not:
MOV A, @R0 ; загрузка байта из последовательности
CPL A ; инверсия аккумулятора (лог. "НЕ")
MOV @R0, A ; запись инвертированного значения в память
INC R0 ; инкремент адреса в R0
DJNZ R2, lp_not ; цикл, пока R2 > 0

; выполнение логической операции  «И»: A[i] & B
MOV R0, #Arr ; загрузка адреса массива в регистр R0
MOV R2, #7 ; счетчик элементов
lp_and:
MOV A, @R0 ; загрузка ст. байта числа последовательности
ANL A, #HIGH(B_) ; лог. И аккумулятора и ст. байта операнда B
MOV @R0, A ; запись значения в память
INC R0 ; инкремент адреса в R0
MOV A, @R0 ; загрузка мл. байта числа последовательности
ANL A, #LOW(B_) ; лог. И аккумулятора и мл. байта операнда B
MOV @R0, A ; запись значения в память
INC R0 ; инкремент адреса в R0
DJNZ R2, lp_and ; цикл, пока R2 > 0

; выполнение логической операции «стрелка Пирса»: A[i] ↑ B
; A[i] = A[i] | B
MOV R0, #Arr ; загрузка адреса массива в регистр R0
MOV R2, #7 ; счетчик элементов
lp_notor:
MOV A, @R0 ; загрузка ст. байта числа последовательности
ORL A, #HIGH(B_) ; лог. ИЛИ аккумулятора и ст. байта операнда B
CPL A ; инверсия значения аккумулятора
MOV @R0, A ; запись значения в память
INC R0 ; инкремент адреса в R0
MOV A, @R0 ; загрузка мл. байта числа последовательности
ORL A, #LOW(B_) ; лог. ИЛИ аккумулятора и мл. байта операнда B
CPL A ; инверсия значения аккумулятора
MOV @R0, A ; запись значения в память
INC R0 ; инкремент адреса в R0
DJNZ R2, lp_notor ; цикл, пока R2 > 0

SJMP Start ; зацикливание программы

; значения чисел набора
iniA:
DW 5365h, 0a577h, 5435h, 0e306h, 3333h, 444eh, 4fe6h

END